!!ARBfp1.0

#ambient lightmap light pass
#Author: Rich Whitehouse
#---------------------------------------------------------------------

#texture0 is the decal

OUTPUT	out = result.color;
TEMP	dcal, nrml, temp, cbrf, lm;
PARAM	lightColor = program.env[1];
PARAM	mulf = {2.0, 2.0, 2.0};
PARAM	subf = {-1.0, -1.0, -1.0};

#fetch the textures
TEX	dcal, fragment.texcoord[0], texture[0], 2D;
TEX	nrml, fragment.texcoord[0], texture[1], 2D;
TEX	lm, fragment.texcoord[3], texture[3], 2D;

MAD	nrml, nrml, mulf, subf;
#re-normalizing interpolated normal does still improve visual quality,
#but i'm so horribly fill-bound that i skip it on the ambient.
#DP3	temp, nrml, nrml;
#RSQ	temp, temp.x;
#MUL	nrml, nrml, temp;

#no need to renormalize, since the vector doesn't change across surfaces for ambient
#DP3	temp, fragment.texcoord[1], fragment.texcoord[1];
#RSQ	temp, temp.x;
#MUL	temp, temp.x, fragment.texcoord[1];

DP3	temp.x, nrml, fragment.texcoord[1];
MAD	temp.x, temp.x, 0.5, 0.5;
MOV	temp.y, 0.5;

#look into the gradient map
TEX	temp, temp, texture[2], 2D;
ADD	temp, temp, lm;
MIN	temp, temp, 1.0;

MUL	temp.xyz, dcal, temp;
MUL	temp.xyz, lm, temp; #factor in lightmap color
MUL	temp.xyz, lightColor, temp;
MOV	temp.w, dcal.w; #set alpha component by decal

MOV	out, temp;

END
